#include "syscall.h"

// https://man7.org/linux/man-pages/man2/syscall.2.html

__attribute__ (( noinline ))
long
do_syscall( long number, ... ){

	(void) number;

	__asm__(
		"mov	%rdi,%rax	\n"	// Syscall#
		"mov	%rsi,%rdi	\n"	// 1st Arg
		"mov	%rdx,%rsi	\n"	// 2nd Arg
		"mov	%rcx,%rdx	\n"	// 3rd Arg
		"mov	%r8,%r10	\n"	// 4th Arg
		"mov	%r9,%r8		\n"	// 5th Arg
		"mov	0x8(%rsp),%r9	\n"	// 6th Arg
		"syscall		\n"
		"retq			\n"
	);

	// not reached
	return -1;
}
